Teleporting Ants & Dynamic Programming

  Рет қаралды 165,635

A Bit Wiser

A Bit Wiser

Жыл бұрын

Codeforces Global Round 15
Problem 1552F. Telepanting
codeforces.com/problemset/pro...
Please leave any constructive criticism in the comments!
Submission to 3b1b's Summer of Math Exposition 2
Written and Animated by: Henry Liu, Samuel Brashears
Produced and Narrated by: Henry Liu
Channel Art by: Amanda Nguyen
Music Licensed by: APM Music @ www.apmmusic.com/
This video was made possible by the open source library manim, created by 3blue1brown and maintained by Manim Community: www.manim.community/
Video Source Code: github.com/henryliuser/manim-cp/

Пікірлер: 460
@rwarazor
@rwarazor Жыл бұрын
for all I know (I have rating of 2194 on cf) for any solution to this problem, we would need to find first x[j] greater than y[i] for all i=1..n and we would either need to sort y, or do n binary searches. We can't do n binary searches in O(n) time, and we can't sort general array in less than O(n log n), but what we can do is use constraint that y[i] < 1e9 and use radix sort(basically 2 count sorts in this case, but for numbers not up to 1e9 but 1e4.5, so linear time since n is up to 2e5), but this feels very unsatisfactory and leaves savory taste in mouth, so I would leave this problem at being O(n log n)
@ABitWiser
@ABitWiser Жыл бұрын
I believe you're correct. I made that challenge after briefly thinking of a solution where we can precompute the j values using 2 pointers. However, I realize that this depends on the Y values being sorted. I've removed that from the description. Nice catch!
@snk-js
@snk-js Жыл бұрын
I am newbie in competitive programming and will try that problem now and every piece of info here is helping, thanks a lot sir.
@naghus_cat
@naghus_cat Жыл бұрын
You are forgetting that radix sort is linear in the length of the list only if the length of the keys isn't tied to the length of the list. The time complexity of radix sort is O(w n), where w is the length of a key. In this case we have that w = O(log n), thus radix sort has the same complexity as quicksort.
@rwarazor
@rwarazor Жыл бұрын
@@naghus_cat according to statement, all numbers are less then 1e9, so w = log(1e9) = 30 = O(1). Then technically radix sort would be linear. If we treat 15 bits as 1 digit, then we will only have 2 iterations of radix sort. Of course all of that works only because of the constraint y < 1e9
@naghus_cat
@naghus_cat Жыл бұрын
@@rwarazor Although I would like to agree with you, that is a trick you can't apply when doing algorithm analysis. Applying the same logic I could sort the list in constant time, because n
@gurjotcheema5988
@gurjotcheema5988 Жыл бұрын
No one can explain a 2200-rated problem better than this... definitely made me a bit wiser.
@cobalius
@cobalius Жыл бұрын
I was just thinking about how damn difficult that might have been. At least 1900 (similar to chess problems).
@Gabriel_JudgeofHell
@Gabriel_JudgeofHell Жыл бұрын
is this chess or am i lost
@amirnuriev9092
@amirnuriev9092 Жыл бұрын
​@@Gabriel_JudgeofHell difficulty rating on a coding competitions platform, it's supposed to be similar to elo
@Gabriel_JudgeofHell
@Gabriel_JudgeofHell Жыл бұрын
@@amirnuriev9092 oh ok where website
@amirnuriev9092
@amirnuriev9092 Жыл бұрын
@@Gabriel_JudgeofHell codeforces
@shivam-tiwari19
@shivam-tiwari19 Жыл бұрын
This video actually looks like one of those 4m subscriber channels, great job man!
@shadowpenguin3482
@shadowpenguin3482 Жыл бұрын
Damn I had to read this comment to see that he had only 606 subscriber. His video quality feels like 3b1b, who has a lot more subscribers. He has 607 now :) props to him, I am sure the number of subscribers will explode soon. Amazing how this was his first video
@TheOofster123
@TheOofster123 Жыл бұрын
@@shadowpenguin3482 978 NOW
@typicwhisper6569
@typicwhisper6569 Жыл бұрын
That's what #Some2 was meant for
@shivam-tiwari19
@shivam-tiwari19 Жыл бұрын
@@typicwhisper6569 what does that mean
@Thanjin_sama
@Thanjin_sama Жыл бұрын
Better tbh
@furkanunsal5814
@furkanunsal5814 Жыл бұрын
I solved the problem much differently and pure mathematically before watching the video. it is very hard to explain a solution in text form but the main idea was to see the portals as binary numbers. I split the problem into two. evaluating how many times the player has entered a portal (to teleport not passover) and then calculating the total distance traveled. The second problem's solution was easy I just had to calculate the difference in position between the portal and the teleportation target to calculate the "cost" of the teleportation. the total length of the line plus all the costs were equal to the total distance traveled. now for the solution to the first part, look at the first example with 4 portals (red, orange, yellow, green). in the solution of this part ignore all the distances. if you look at the first red portal it teleports the player right behind itself and is thus equivalent to a binary number with one digit. orange also is a one digit number but yellow perfectly encapsulates orange but no other portal so they collectively create two digit binary number. green is encapsulating the entire one digit and two digit numbers. green is not symbolized as 3 digit but (1 + 2)+1 digits. plus operation is not summation in this notation but symbolizes that those two numbers have to be calculated independently. so collectively the table for the puzzle is 1+2+(1+2+1). we have to take the initial positions of the portals into account. the first one digit portal is closed so it has the value of 1. notice 1 is the maximum value a one digit binary number can hold so the next stop over it will pass it. orange and yellow collectively two digit number seems to have the value (0x01=1) but you can observe they act as inverted. so actually they have the value (0x10 = 2) of 2. and lastly green was symbolizing the entire copy of the puzzle plus itself but when the player passes it, all the portals will be open. so the value for green is (0 + 0 + 0) binary digit table = 1+2+(1+2+1) initial value table = 1+2+(0+0+0) we are close to be able to calculate total teleportation count. just remember that one digit binary numbers can hold maximum of 1 and leak for the value of 2. similarly two digit numbers can hold the maximum of 3 and leaks for the value of 4. binary digit table = 1+2+(1+2+1) initial value table = 1+2+(0+0+0) max value table = 1+3+(1+3+1) difference table = 0+1+(1+3+1) when we sum the difference table 1+1+3+1 = 6 you can see that player will teleport 6 times. conveying the idea behind these tables isn't that easy in text form so if they are not clear try to read it again and calculate them by yourself this is the best that I can do. lastls we have to calculate the costs. as I said calculating the cost for a portal is easy we have to calculate the distance between the portal and the target but when we unite two portals into a multi digit number since the two portals creating that multi digit (in this example two) number can have different costs we have to symbolize them independently. for this example in the case of orange and yellow portals, their costs are 1 and 3 so we will notate them as (1+3) for the 2 digit number. this says that if the player enters the first digit the cost is 1 and if it enters the second digit the cost is 3. we need to somehow evaluate how many times which digit will flip while counting in binary. I will calculate that for the general case later but for two digit binary (00 10 01 11) the first digit will flip every time and the second digit will flip every two times. collectively first 4 times and second 2 times. let me write the tables again this time with the cost table too. cost table = 1+(1+3)+1+(1+3)+7 binary digit table = 1 + 2 + (1 + 2 + 1) initial value table = 1 + 2 + (0 + 0 + 0) difference table = 0 + 1 + (1 + 3 + 1) total cost table = 0+(1+0)+1+(1+3+1)+7 = 14 total distance travelled = cost + distance = 14 + 9 = 23 the reason for the cost for the second two digit number to be not (1+3) but (1+3+1) is because while counting 00 10 01 11 first digit is flipped from 0 to 1 twice and second digit once. thus when the binary digit table is constructed total distance traveled can be evaluated mathematically with near zero computational cost. I have spent around 2 hours for the solution and an additional 2 hours watching the video and writing this comment. I'm very happy if you have read it to here and I hope you like the solution. have a nice day.
@illuminatelair8084
@illuminatelair8084 Жыл бұрын
nerd!
@furkanunsal5814
@furkanunsal5814 Жыл бұрын
@@illuminatelair8084 haha! this is my job tho.
@lchi1234
@lchi1234 Жыл бұрын
Yeah at the beginning of teh vid I was expecting a binary related explanation similar to this lol
Жыл бұрын
I had a similar idea. I wonder whether we can actually view the idea in the video as a variant of yours. I think they might be related.
@sumitlahiri4973
@sumitlahiri4973 Жыл бұрын
Yup, this makes sense! Thanks for the long answer, much needed.
@__8120
@__8120 10 ай бұрын
The sum on contiguous elements idea was genius, I never would have thought of that but it's so obvious in hindsight
@pocces5528
@pocces5528 Жыл бұрын
Banger video
@onagain2796
@onagain2796 Жыл бұрын
Banger commenter (call me)
@salaheddin3113
@salaheddin3113 Жыл бұрын
Probably the best explanation to a problem I've ever seen
@i_am_acai
@i_am_acai Жыл бұрын
I really liked how you showed how much DP speeds things up at 7:18. I also like how you cut off the music at 6:37 when making your conclusion. One criticism I have is you sometimes show graphics on the screen only while you talk about it, so it's hard to visually digest what you're showing and listen in that short time (ie sometimes it's a bit fast such as at 5:30)
@ABitWiser
@ABitWiser Жыл бұрын
Thanks for your feedback!
@saurabhshah9266
@saurabhshah9266 Жыл бұрын
Awesome video. I noticed this is your first on KZbin, I hope you keep it up! Really tough problem but you explained it well. Always wished there was a 3b1b for data structure and algs. Could be you.
@gzethicus
@gzethicus Жыл бұрын
So I might have taken your challenge to solve this problem in O(n) a bit too seriously. It took a variant of counting sort to allow building a hash map from each exit to the closest entrance in O(n), so we can skip the binary search and replace it with an access to the hash map in O(1), thus resulting in a total complexity of O(n) (where n is the length of the road rather than the portal count, though).
@Palparepa
@Palparepa Жыл бұрын
I did something similar. No hash, just a simple array, with an element for each node, storing the steps needed to go from the start to that node, assuming all portals are open.
@gzethicus
@gzethicus Жыл бұрын
@@Palparepa I also thought of doing that at some point, but I wanted to respect the 256MB limit for the challenge, which I believe this solution can't satisfy with roads up to 10^9 in length. Congrats on O(n) time complexity anyways !
@jakegoat2677
@jakegoat2677 Жыл бұрын
I'm shocked that this is the first video on this channel, the quality is something I would expect it to take months or even years to achieve. Can't wait for the next one!!!
@tagberli
@tagberli Жыл бұрын
As a green coder (1200-1400 CF) I can say that I understood the 2200 rated problems solution proving that this guy have put a great work into his explanation!
@ABitWiser
@ABitWiser Жыл бұрын
Thanks! We hoped to guide viewers through the solution while letting you all make a few leaps of your own. Happy to hear you followed along!
@andrw_
@andrw_ Жыл бұрын
Incredible video and excellent teaching. Like many others, I’m amazed this is your first video! You earned a sub - can’t wait to see what else you have for the future!
@mananshah2140
@mananshah2140 Жыл бұрын
Absolute gold. Keep it up. Wish to see several algorithm implementations and problems in this format.
@RayZhaTV
@RayZhaTV Жыл бұрын
i really liked the animations, especially the last part where the lines of code are highlighted each step and you can see where the results move to.
@thestemgamer3346
@thestemgamer3346 Жыл бұрын
The animations were really nice, particularly for the DP graph visualization. Very creative.
@mathguy198
@mathguy198 Жыл бұрын
You are an awesome storyteller and a talented movie maker, and not to mention an excellent teacher whatsoever.
@sun3k
@sun3k Жыл бұрын
Checked out your channel to see more vids and realised thats the only one. The music/animation was honestly amazing
@ifroad33
@ifroad33 Жыл бұрын
Loving the animations. Really made the video so much more understandable. Really great job!
@EvgenyAlterman
@EvgenyAlterman Жыл бұрын
Just great! Can’t wait for the next video. And any video made using manim have to be great:)
@brensenvillegas7177
@brensenvillegas7177 Жыл бұрын
Absolutely incredible. Amazing content right out the gate! Keep making awesome vids
@marwaqawas7040
@marwaqawas7040 Жыл бұрын
Great video! We definitely need more of that. Keep it up man
@StolenID
@StolenID Жыл бұрын
Very Video, much good, such wow. First video, and despite some audio that's clearly form different recording sessions its mostly flawless. Keep on rocking dude.
@harshmishra6072
@harshmishra6072 Жыл бұрын
Oh man.. you took it to the next level. Also how many hours did you spend making this?
@hitesh6856
@hitesh6856 Жыл бұрын
wow such a high quality video for a competitive programming problem. Great explanation and visualization. I just love it.
@TheSalaho1
@TheSalaho1 Жыл бұрын
This is unbelievably good explanation, please keep up and post more!
@mihirachyuta7272
@mihirachyuta7272 Жыл бұрын
Love this video and the animations. Keep making more of these videos please
@gosunov
@gosunov Жыл бұрын
I've always wanted such content on youtube, and finally here it is. Looking forward for next videos. But personally for me it was very hard to follow the solution, the key part about what we store as dp_i and how we calculate it, is explained too briefly. (although I am 1900 on codeforces).
@gosunov
@gosunov Жыл бұрын
And maybe music is a little loud
@ABitWiser
@ABitWiser Жыл бұрын
Hi, sorry about that! dp_i is the time it takes to enter a portal and return back to the same position. It is calculated as dist_i + cost_i: Dist_i is X_i - Y_i, the distance between the entrance and exit. Cost_i is the sum of the return trip times of all the portals we encounter in between i_th exit and the i_th entrance. For some intuition on why this works: consider the path you take when you go into an entrance. 1. X_i, jump to Y_i 2. Walk until u reach an entrance (which is guaranteed to be open) 3. Go into entrance; recurse. 4. Continue past portal, walk until next entrance... Repeat steps 2-4 until you reach entrance i. Each "recurse" has a fixed cost that we've already computed! That's the corresponding dp value.
@gosunov
@gosunov Жыл бұрын
​@@ABitWiser Yeah thanks for explanation, I have totally understood the algorithm. In my original comment I just wanted to say, that I think it would be better, if explanation in video were somewhat smoother (I don't really know how to make it so).
@michaelmam1490
@michaelmam1490 Жыл бұрын
I think the music volume is great
@davidmcdonnel4831
@davidmcdonnel4831 Жыл бұрын
I had to rewatch too, not because I misunderstood the concept, but because the variables were not named. In the final solution I had to rewind to where the arrays X, Y, and S were defined 7 minutes earlier in the video at 5:23. Please name your variables appropriately if presenting to an audience (be they viewers, other developers working on the code base, or most likely future you that forgot what you were thinking when you initially wrote it). Let the compiler get rid of the extra characters. Hard drives are a lot cheaper than salaries.
@maxamillion6042
@maxamillion6042 Жыл бұрын
Please make more videos, the wonderful quality and entertainment value this has is beautiful, thank you.
@aschmelyun
@aschmelyun Жыл бұрын
The production value, explanation, pacing, audio, visuals, everything about this screams top-notch quality. Can't wait to see more!
@ashleymavericks
@ashleymavericks Жыл бұрын
GOAT explanation skills, amazing work! Hoping for a lot more great videos in the near future.
@tanchienhao
@tanchienhao 10 ай бұрын
Amazing effort for a video about one dp problem! Hope to see another entry this year for some3!
@platinummyrr
@platinummyrr Жыл бұрын
Fantastic video! Use of prefix sums is pretty genius.
@ibemper1850
@ibemper1850 Жыл бұрын
Thank you for explaining this so nicely, I gave this problem a try before looking at the solution and when I saw my solution matched up with the one you presented I was very happy, this is a great explanation of dynamic programming, great video!!
@albertocalabrese2958
@albertocalabrese2958 Жыл бұрын
Incredible video! When I first studied dynamic programing I had lots of troubles wrapping my head around it and seeing it explained so clearly was really nice! I wish your video came out earlier 🤣
@0xggbrnr
@0xggbrnr Жыл бұрын
Excellent video. Very well-explained and demonstrated. I hope you post more.
@Sofia-ts6gy
@Sofia-ts6gy Жыл бұрын
the motion graphics illustrating the algorithm are absolutely delightful!
@berggbergg
@berggbergg Жыл бұрын
Amazing content, great animations. Really hope you still have plans of making more videos!
@dio707.
@dio707. Жыл бұрын
Loved it! Thank you for this and all upcoming videos, orz
@FloydMaxwell
@FloydMaxwell Жыл бұрын
Fantastic visuals. I wonder how many followed it all while watching the video without pausing it. I sure didn't. But still I'm impressed.
@code_explorations
@code_explorations Жыл бұрын
Fantastic. What a superb first video. I hope there will be more, but even if not, wow.
@HimanshuLilhore
@HimanshuLilhore Жыл бұрын
Just soo good. Please, never stop making these ❤❤
@TheDmviper
@TheDmviper Жыл бұрын
The quality of this video is amazing! I really liked how well you made the music sync up to the algorithm at the end with a satisfying ding every time the cost was calculated. The part at 10:30 felt a bit rushed though, I had to rewatch and study your python implementation to realize why exactly you needed to binary search to find the index of the ps array, but other than that it was an excellent video and a delight to watch.
@ABitWiser
@ABitWiser Жыл бұрын
Thanks for the helpful notes and kind words
@shambhav9534
@shambhav9534 Жыл бұрын
Yeah, I too needed a lot, and I mean, lot of thought to understand why a binary search was needed. It's a good thing though. I don't want to be this failure programmer who watches videos with an off mind but can't code or think anything himself. I like this!
@itellyouforfree7238
@itellyouforfree7238 Жыл бұрын
The interesting thing is that one does not NEED to to binary search, and actually avoiding it lowers the time complexity from O(n logn) to O(n).
@stefangarofalo3131
@stefangarofalo3131 Жыл бұрын
you probably are the best teacher ever for dsa. I have never seen a better explanation
@mayurmhatre9925
@mayurmhatre9925 Жыл бұрын
I'm a beginner EASY coder and this video popped up in my feed, my Feedback :- Good Work 👍🏻, nicely explained, with little bit of pace management, even beginner's like me can understand the Problem Solving aspect. Thank You.
@234234234234ist
@234234234234ist Жыл бұрын
Damn thats some quality work! Your Channel needs to blow up. You have my subscription at least :)
@anonidk7235
@anonidk7235 Жыл бұрын
Beautifully done. Simply awesome
@SashwatMahalingam
@SashwatMahalingam Жыл бұрын
An academic epiphany of many proportions
@andreigrigore3512
@andreigrigore3512 Жыл бұрын
I just subscribed, I love competitive programming and I think this channel will help me on my journey.
@sirpikapika1129
@sirpikapika1129 Жыл бұрын
This is amazing! Calling now that this will be in the winners video :D
@angelasun8896
@angelasun8896 Жыл бұрын
This is the best video on the internet, until you upload the next one
@boiimcfacto2364
@boiimcfacto2364 Жыл бұрын
When I saw your video mentioned in 3B1B's SOME2 results video, I was dead sure you were gonna win. Welp, like he said, every video is the best for different demographics of people, and this is the one for me. Fucking incredible video, and thank you for making this!
@somebodyhere3160
@somebodyhere3160 Жыл бұрын
This is a great video! But the part near 6:40, explaining how dp was calculated was paced a bit too quick, and I had to rewatch that part to understand it. Otherwise, a great explanation of a hard problem.
@ABitWiser
@ABitWiser Жыл бұрын
Thanks, we appreciate your feedback!
@someonlinevideos
@someonlinevideos Жыл бұрын
@@ABitWiser it’s a we!?
@ABitWiser
@ABitWiser Жыл бұрын
@@someonlinevideos Yeah! It's two of us, credits in the description :)
@discreet_boson
@discreet_boson Жыл бұрын
Excellent video, this is 3b1b-quality explaining!
@monsieuralexandergulbu3678
@monsieuralexandergulbu3678 Жыл бұрын
Super nice video! Although one thing is not nice, please process your mic's sounds so both audio channels would have equal volume 🙏
@ABitWiser
@ABitWiser Жыл бұрын
Thanks for letting us know, we'll fix that.
@mvdrider
@mvdrider Жыл бұрын
Thank you for the hard work and for sharing it!
@mohammedjawahri5726
@mohammedjawahri5726 Жыл бұрын
that was incredible man, please keep on going :)
@sid5468
@sid5468 Жыл бұрын
Great first video. Loved it. Subscribed.
@justaknifeinalake7251
@justaknifeinalake7251 2 ай бұрын
This is a really awesome video with great production❤
@brianrainer
@brianrainer Жыл бұрын
Wow amazing visualization! Good job!
@tunafllsh
@tunafllsh Жыл бұрын
Great video! It took me some time to figure out some claims when you tell us to convince ourselves. A brief explanation or key idea would make it more digestable.
@AvinashYadav-tq8si
@AvinashYadav-tq8si Жыл бұрын
Thank you for making such a great video!
@dozheiny5996
@dozheiny5996 Жыл бұрын
this video is really impressive, please make more!
@shambhav9534
@shambhav9534 Жыл бұрын
Great video. One thing I liked about this is that it didn't break-down the solution, instead it just introduced the ideas and let the viewer understand it by though. I loved this methodology for this problem is particular, but you may run into issues doing this with much more complicated problems.
@abhisheksharma1031
@abhisheksharma1031 Жыл бұрын
This is so well done !!
@Yous0147
@Yous0147 Жыл бұрын
Great video, subbed from here. I could follow right up until 8:50 then it started getting over my head, I think I'll have to watch the last part a couple of times before I start to get it.
@user-tr7ys1ym7g
@user-tr7ys1ym7g Жыл бұрын
amazing video!!! Please continue to create similar video.
@Splish_Splash
@Splish_Splash Жыл бұрын
3000 subscribers? no way, this is an amazing work. And i want to say that in the bisect method we can specify "Lo" and "hi" parametres(the start and end indices in the array where we want to search our element), so if we're in portal X[i] and go out in Y[i], we don't need to search all over X to find a nearest portal, we need to search in X[from 0 to i], so if we specify bisect(X, Y[i], hi=i) time complexity for all calls will be: log(1)+ log(2) + log(3) + ... + log(n) = log(n!) n / 2 * log(n / 2)
@itellyouforfree7238
@itellyouforfree7238 Жыл бұрын
What's the point of "improving" O(nlogn) to another O(nlogn), when the optimal solution is O(n)? Just find a way to avoid bisecting at all, as it's unnecessary
@Splish_Splash
@Splish_Splash Жыл бұрын
@@itellyouforfree7238 there's no O(n) solution
@itellyouforfree7238
@itellyouforfree7238 Жыл бұрын
@@Splish_Splash after reading the problem on codeforces i realized the video is slighty imprecise. it gives the impression that there is only one variable n, the number of the portals, and the length of the track is always 2n. instead there are two variables, n = "no. of portals", M = "length of track", with 2n
@Sondelll
@Sondelll Жыл бұрын
Hats off for the informative video, good stuff! I can't implement binary search off the top of my head for the life of me, not having actually ever done it. Caught that pattern at 2:14, the movement straight up looked like counting in binary with variable offsets. Fascinating.
@snooglemunch
@snooglemunch Жыл бұрын
Binary Search: Assume array is sorted and you have access to the size. Define lower/upper indices to be 0 and size() - 1, respectively. Sum the indices and divide by 2 (integer division), this is your mid index. Is A[mid] equal to your value? If yes, then we're done. Otherwise, if its smaller, then the upper index becomes mid index - 1. If its larger then the lower index becomes mid index + 1. Loop. Stop the loop if lower > upper (value doesn't exist in array).
@vipenloka669
@vipenloka669 Жыл бұрын
that was smooth, well done!!
@btmillion2813
@btmillion2813 Жыл бұрын
Very promising video. Looking forward to more!
@Bazzzzz93
@Bazzzzz93 Жыл бұрын
Fantastic video. Great job!
@rianfantozzi7827
@rianfantozzi7827 Жыл бұрын
This is so high quality! I thought I was watching a 3blue1brown video
@DavidTriphon
@DavidTriphon Жыл бұрын
I really appreciated this video. I paused at the 2 minute mark, solved it myself in O(n log n), and then saw that I came to the same conclusions you came to in this video. It felt very validating! Thank you for the great visual and description of your terms. I wouldn't have been sure I had actually had the same solution as you if you hadn't. Also yours is much cleaner and easier to understand than mine.
@giannismaris13
@giannismaris13 Жыл бұрын
Every math or CS student should subscribe! Great work man, cant wait to see more of DP or Machine Learning ect ...
@karamboubou8579
@karamboubou8579 Жыл бұрын
Amazing work, you earned a subscriber!
@felipe2637
@felipe2637 Жыл бұрын
amazing work man, keep it up!!!
@paulbetts4984
@paulbetts4984 Жыл бұрын
Fantastic video. Keep up the great work.
@patricksmith1520
@patricksmith1520 Жыл бұрын
Great video. Good start. Keep up the good work.
@notsoclearsky
@notsoclearsky Жыл бұрын
Keep making videos, one day this channel would be huge
@johnyjohnjohnson1317
@johnyjohnjohnson1317 Жыл бұрын
Greate video, Thanks for the sorce code of the animations. i am also on codeforces. I am probably learning more there as anywhere else.
@raymondlee6661
@raymondlee6661 Жыл бұрын
Looking forward to more of these!
@BoditXD
@BoditXD Жыл бұрын
Great explanation, felt really absorbed during whole video
@hdanielb.m.4125
@hdanielb.m.4125 Жыл бұрын
Wow I really liked this explanation, I want more!
@fabioteixeira868
@fabioteixeira868 Жыл бұрын
Wonderful video! Stated the problem and worked through it with great pedagogy. Got me wondering if there is a real-life problem that can be modeled as this ant walk and if this solution to it enabled some new technology or product. Got yourself a new sub from Brazil! Cheers!
@abhiupadhyay3615
@abhiupadhyay3615 Жыл бұрын
Great Explanation. You sure must upload more
@ishwarendra
@ishwarendra Жыл бұрын
superb work man!
@Choochificational
@Choochificational Жыл бұрын
this is fqntastic start to a youtube channel, great job! i would make sure to balance your music a little softer tho, its almost overpowering your voice. keep up the good work bro, you have a new subscriber
@ineverchangemyplayericon3016
@ineverchangemyplayericon3016 Жыл бұрын
Nice first video, My left Ear enjoyed it.
@edvinbryntesson2028
@edvinbryntesson2028 Жыл бұрын
Looking forward to the next one! ❤️
@nananou1687
@nananou1687 Жыл бұрын
Please make more videos This was very well explained
@potatopotato4676
@potatopotato4676 Жыл бұрын
I don't see 84 subscribers, I see 84M!
@viktorklyestov2108
@viktorklyestov2108 Жыл бұрын
We need more! More videos!
@PrevalentAA
@PrevalentAA Жыл бұрын
Please keep making these!
@kinershah464
@kinershah464 Жыл бұрын
Great animation and explanation. But finding patterns can be tricky. And even tricky is finding how to use these patterns to solve the problem. More tricky is to make the solution optimal by using tricks like prefix sums, etc like you mentioned in the video. For experts this is easy because of practice and wide variety and number of problems they solve each day.
@alabaz
@alabaz Жыл бұрын
this was superbly presented!
@isbat31416
@isbat31416 Жыл бұрын
I feel like I'm going to love this channel....
@dmitriynikitinskyy3731
@dmitriynikitinskyy3731 Жыл бұрын
I learned so much!!!
@aakashuniyal6806
@aakashuniyal6806 Жыл бұрын
Bruh this content is gold, subscribing and expecting more gold content here 👋
@blackbriarmead1966
@blackbriarmead1966 Жыл бұрын
dynamic programming is a weak spot I need to work on for coding interviews. Always good to get more exposure on the subject
Giving Personality to Procedural Animations using Math
15:30
t3ssel8r
Рет қаралды 2,4 МЛН
格斗裁判暴力执法!#fighting #shorts
00:15
武林之巅
Рет қаралды 58 МЛН
The weirdest paradox in statistics (and machine learning)
21:44
Mathemaniac
Рет қаралды 1 МЛН
How principled coders outperform the competition
11:11
Coderized
Рет қаралды 1,5 МЛН
Candidate Master in 1 Year - This Strategy Works Wonders
10:03
Colin Galen
Рет қаралды 122 М.
The Art of Linear Programming
18:56
Tom S
Рет қаралды 603 М.
How are memories stored in neural networks? | The Hopfield Network #SoME2
15:14
Solving the heat equation | DE3
14:13
3Blue1Brown
Рет қаралды 1,2 МЛН